function sbp = generate_lepidoptera_parametrisation(rx, ry, a, b, c)

    sbp.gamma = @(ss) [rx*sin(2*pi*ss); ...
                       ry*(a*cos(2*pi*ss) + b*cos(4*pi*ss) + c*cos(6*pi*ss))];

    sbp.dgamma = @(ss) 2*pi * [rx*cos(2*pi*ss); ...
                               -ry*(a*sin(2*pi*ss) + 2*b*sin(4*pi*ss) + 3*c*sin(6*pi*ss))];

    sbp.d2gamma = @(ss) 4*pi^2 * [-rx*sin(2*pi*ss); ...
                                  -ry*(a*cos(2*pi*ss) + 4*b*cos(4*pi*ss) + 9*c*cos(6*pi*ss))];

    sbp.ngamma = @(ss) cnormalise([0, 1; -1, 0] * sbp.dgamma(ss));
end

function A = cnormalise(A)
    A = A ./vecnorm(A);
end