function plot_quad_mesh(qm, zs, cs)
    if nargin < 2
        patch('Faces', qm.cs.', ...
              'Vertices', qm.vs.', ...
              'FaceColor', 'none');
          axis 'equal';
    else
        if nargin < 3
            cs = zs;
        end
        xl = minmax(qm.vs(1, :)) * [1.05 -0.05; -0.05, 1.05];
        yl = minmax(qm.vs(2, :)) * [1.05 -0.05; -0.05, 1.05];
        % harmonic fct has extremes on boundary
        zl =  minmax(zs(qm.bs > 0)) * [1.1 -0.1; -0.1, 1.1];
        patch('Faces', qm.cs.', ...
              'Vertices', [qm.vs.', zs.'], ...
              'FaceVertexCData', cs.', ...
              'FaceColor', 'interp', ...
              'EdgeColor', 'none');
        xlim(xl);
        ylim(yl);
        zlim(zl);
        d = daspect;
        d(1:2) = geomean(d(1:2));
        d(3) = 2.5 * d(3);
        daspect(d);
    end
end