% the testing ground
%%  to check add_star_shaped_parametrisation function
paras = 'ring';  % or 'circle', 'trefoil', 'genus3', 'genus5', 'rhopalocera'
[mbp, hmax] = generate_test_parametrisation(paras);
h = 0.01;
qm = generate_quad_mesh(mbp, h);

figure();
plot_quad_mesh(qm);

%%  to check potential_cauchy function
u = @(x) x(1, :).^2 - x(2, :).^2;
dnu = @(x, nx) 2*x(1, :).*nx(1, :) - 2*x(2, :).*nx(2, :);

dcd = interpolate_cauchy_data(mbp, 300*ones(size(mbp)), u, dnu);

% needs potential cauchy
zs = interpolate_onto_quad_mesh(qm, dcd);
[~, err] = interpolate_onto_quad_mesh(qm, dcd, u);

figure();
plot_quad_mesh(qm, zs);

disp(['Error is: ' num2str(err)]);

%%  to check nystroem_cauchy function
dcd2 = nystroem_cauchy(mbp, 300*ones(size(mbp)), u, dnu, true(size(mbp)));

[zs2, err2] = interpolate_onto_quad_mesh(qm, dcd2, u);

figure();
plot_quad_mesh(qm, zs2);

disp(['Error is: ' num2str(err2)]);